/**
Klasse der Begrenzungsebenen des Darstellungsraums.
Copyright (C) 2006, Rene Heuer, Salingtwiete 4g. (D)20535 Hamburg
eMail: heuer@exmpl.de
Dieses Programm ist freie Software. Sie können es unter den Bedingungen der
GNU General Public License, wie von der Free Software Foundation veröffentlicht,
weitergeben und/oder modifizieren, entweder gemäß Version 2 der Lizenz oder
(nach Ihrer Option) jeder späteren Version.
Die Veröffentlichung dieses Programms erfolgt in der Hoffnung, daß es Ihnen von
Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, sogar ohne die implizite
Garantie der MARKTREIFE oder der VERWENDBARKEIT FÜR EINEN BESTIMMTEN ZWECK.
Details finden Sie in der GNU General Public License.
Sie sollten ein Exemplar der GNU General Public License zusammen mit diesem
Programm erhalten haben. Falls nicht, schreiben Sie an die
Free Software Foundation, Inc.,
59 Temple Place,
Suite 330,
Boston, MA 02111-1307,
USA.
*/
import java.awt.*;
import java.awt.geom.*;

public class Plane {
static public final int XY = 1;  // Ebene hat XY-Orientierung im Darstellungsraum
static public final int YZ = 2;  // Ebene hat YZ-Orientierung im Darstellungsraum
static public final int XZ = 4;  // Ebene hat XZ-Orientierung im Darstellungsraum

public double  shift = 0.0;         // Verschiebung senkrecht zur Ebene
public int     p0    = 0;           // Nummer der Ecke mit Start-Farbe
public int     p1    = 2;           // Nummer der Ecke mit Stop- Farbe
public Color   start = Color.green; // Farbe bei kleinen Werten (p0)
public Color   stop  = Color.white; // Farbe bei grossen Werten (p1)
public float   trans = 0.35f;       // 0.2 Transparenz
public Point2D[]   p    = {
                            null,   // erster  Eckpunkt
                            null,   // zweiter Eckpunkt
                            null,   // dritter Eckpunkt
                            null    // vierter Eckpunkt
                           };
private Rectangle2D rect = null;    // unprojiziertes Rechteck der Ebene
// public GeneralPath  path = null;    // GeneralPath der Ebene
public int          how  = 0;       // Orientierung der Ebene

 /**
 CREATOR in der einfachsten Form
 */
 Plane() { }

 /**
 CREATOR mit Festlegung der Orientierung
 @param how: Orientierung der Ebene (XY, YZ, XZ)
 */
 Plane( int how) {
  this.how = how;
 }

 /**
 CREATOR mit Festlegung der Dimension und Orientierung
 @param how: Orientierung der Ebene (XY, YZ, XZ)
 @param rect: rechteckiger, nicht projizierter Bereich
 */
 Plane( int how, Rectangle2D rect) {
  this.how  = how;
  setRectangle( rect);
 }

 /**
 Festlegung der Orientierung
 @param how: Orientierung der Ebene (XY, YZ, XZ)
 */
 public void setOrientation( int how) {
  this.how = how;
 }

 /**
 Festlegung der Dimension der Ebene
 @param rect: rechteckiger, nicht projizierter Bereich
 */
 public void setRectangle( Rectangle2D rect) {
  this.rect = rect;
  p[0] = new Point2D.Double( rect.getX(),                 rect.getY());
  p[1] = new Point2D.Double( rect.getX()+rect.getWidth(), rect.getY());
  p[2] = new Point2D.Double( rect.getX()+rect.getWidth(), rect.getY()-rect.getHeight());
  p[3] = new Point2D.Double( rect.getX()                , rect.getY()-rect.getHeight());
 }
}
