/**
Klasse einer Anwendung des 3D-Displays.
Diese Anwendung zeigt die dreidimensionale Darstellung der Peirce-Folge mit bis zu
14 Generationen.
Dieser Code

*************************************
* STEHT NICHT ZUR FREIEN VERFUEGUNG *
*************************************

Er ist Bestandteil einer Arbeit, die bei den Bundeswettbewerben
"Jugend experimentiert" und nach Sieg und Aufstufung "Jugend forscht"
2005 den/die Landessieg(e) erreichte.
Die Arbeit und damit auch dieses Programm sind also nur als Demo anzusehen und
duerfen NICHT kommerziell genutzt werden oder auf einer anderen Site im Internet
publiziert werden.
*/
import java.awt.*;
import java.util.*;
import javax.swing.*;
import java.awt.event.*;

import javax.swing.BorderFactory;
import javax.swing.border.Border;
import javax.swing.border.TitledBorder;
import javax.swing.border.EtchedBorder;


class Test {
static private final int      GEN = 10;
static private final boolean  LOW = true;
static private final boolean  CNT = false;
static private final boolean  SWX = false;
static private final boolean  CRS = true;
static private final int      XRT = 20;
static private final int      YRT = 15;
static private final int      ZRT =  0;
static private final String   TTL = "Visualisierung der ";
static private final String   CSP = "Wertemenge nach Charles Sanders Peirce";
static private final String   JF  = "Zahlenmenge nach John Farey";
static private final String   FOR = " (Jugend forscht)";

static private String   frmttl = TTL+CSP+FOR;
static private JFrame   frame;
static private TestPane pane;
static private Disp3D   disp;

static private JTextField genFld  = new JTextField( 3);
static private JTextField xrtFld  = new JTextField( 3);
static private JTextField yrtFld  = new JTextField( 3);
static private JTextField zrtFld  = new JTextField( 3);

static private int      generations = GEN;
static private boolean  low         = LOW;
static private boolean  connect     = CNT;
static private boolean  shwax       = SWX;
static private boolean  cross       = CRS;
static private int      xrotVal     = XRT;
static private int      yrotVal     = YRT;
static private int      zrotVal     = ZRT;
static private int      frameW      = 1250;
static private int      frameH      =  900;

static private boolean  farset      = false;

 /**
 Anzahl der Generationen bergeben
 */
 static private int getGenerations() {
 Integer num = null;
  try   {
         num = new Integer( genFld.getText());
        }
  catch (NumberFormatException nfe)
        {
         Toolkit.getDefaultToolkit().beep();
         genFld.setText( ""+GEN);
         return GEN;
        }
 int max = 15;
 int val = num.intValue();
  if (!cross) max++;
  if (farset) max *= 40;
  if (val > 0 && val < max) return val;
  Toolkit.getDefaultToolkit().beep();
  genFld.setText( ""+GEN);
  return GEN;
 }

 /**
 Wert der Rotation um die X-Achse bergeben
 */
 static private int getXRotation() {
 Integer num = null;
  try   {
         num = new Integer( xrtFld.getText());
        }
  catch (NumberFormatException nfe)
        {
         Toolkit.getDefaultToolkit().beep();
         xrtFld.setText( ""+XRT);
         return XRT;
        }
 int val = num.intValue() % 360;
  xrtFld.setText( ""+val);
  return val;
 }

 /**
 Wert der Rotation um die Y-Achse bergeben
 */
 static private int getYRotation() {
 Integer num = null;
  try   {
         num = new Integer( yrtFld.getText());
        }
  catch (NumberFormatException nfe)
        {
         Toolkit.getDefaultToolkit().beep();
         yrtFld.setText( ""+YRT);
         return YRT;
        }
 int val = num.intValue() % 360;
  yrtFld.setText( ""+val);
  return val;
 }

 /**
 Wert der Rotation um die Z-Achse bergeben
 */
 static private int getZRotation() {
 Integer num = null;
  try   {
         num = new Integer( zrtFld.getText());
        }
  catch (NumberFormatException nfe)
        {
         Toolkit.getDefaultToolkit().beep();
         zrtFld.setText( ""+ZRT);
         return ZRT;
        }
 int val = num.intValue() % 360;
  zrtFld.setText( ""+val);
  return val;
 }

 /**
 Action: Rotation um Y-Achse in positive Richtung
 */
 private static Action zrot = new AbstractAction( null, new ImageIcon( "forward.png")) {
                                        public void actionPerformed( ActionEvent ae) {
                                         disp.yrot += 5;
                                         yrotVal = (int)disp.yrot;
                                         yrtFld.setText( ""+yrotVal);
                                         planeDummy.setSelected( true);
                                         pane.repaint();
                                        }
                                       };

 /**
 Action: Rotation um Y-Achse in negative Richtung
 */
 private static Action yrot = new AbstractAction( null, new ImageIcon( "back.png")) {
                                        public void actionPerformed( ActionEvent ae) {
                                         disp.yrot -= 5;
                                         yrotVal = (int)disp.yrot;
                                         yrtFld.setText( ""+yrotVal);
                                         planeDummy.setSelected( true);
                                         pane.repaint();
                                        }
                                       };

 /**
 Action: Rotation um X-Achse in positive Richtung
 */
 private static Action xrot = new AbstractAction( null, new ImageIcon( "down.png")) {
                                        public void actionPerformed( ActionEvent ae) {
                                         disp.xrot += 5;
                                         xrotVal = (int)disp.xrot;
                                         xrtFld.setText( ""+xrotVal);
                                         planeDummy.setSelected( true);
                                         pane.repaint();
                                        }
                                       };

 /**
 Action: Rotation um X-Achse in negative Richtung
 */
 private static Action wrot = new AbstractAction( null, new ImageIcon( "up.png")) {
                                        public void actionPerformed( ActionEvent ae) {
                                         disp.xrot -= 5;
                                         xrotVal = (int)disp.xrot;
                                         xrtFld.setText( ""+xrotVal);
                                         planeDummy.setSelected( true);
                                         pane.repaint();
                                        }
                                       };

 /**
 Action: Rotation um Z-Achse in positive Richtung
 */
 private static Action urot = new AbstractAction( null, new ImageIcon( "rotate.png")) {
                                        public void actionPerformed( ActionEvent ae) {
                                         disp.zrot += 5;
                                         zrotVal = (int)disp.zrot;
                                         zrtFld.setText( ""+zrotVal);
                                         planeDummy.setSelected( true);
                                         pane.repaint();
                                        }
                                       };

 /**
 Action: Rotation um Z-Achse in negative Richtung
 */
 private static Action vrot = new AbstractAction( null, new ImageIcon( "rotate_cw.png")) {
                                        public void actionPerformed( ActionEvent ae) {
                                         disp.zrot -= 5;
                                         zrotVal = (int)disp.zrot;
                                         zrtFld.setText( ""+zrotVal);
                                         planeDummy.setSelected( true);
                                         pane.repaint();
                                        }
                                       };

/**
Action: Intervall [0, 1] darstellen
*/
 private static Action lowAct = new AbstractAction() {
                                        public void actionPerformed( ActionEvent ae) {
                                         low = true;
                                         pane.low = low;
                                         pane.repaint();
                                        }
                                       };

/**
Action: Intervall [1, ?] darstellen
*/
 private static Action highAct = new AbstractAction() {
                                        public void actionPerformed( ActionEvent ae) {
                                         low = false;
                                         pane.low = low;
                                         pane.repaint();
                                        }
                                       };

/**
Action: auf rote Ebene drehen
*/
 private static Action redAct = new AbstractAction() {
                                        public void actionPerformed( ActionEvent ae) {
                                         disp.xrot = 0;
                                         disp.yrot = 0;
                                         disp.zrot = 0;
                                         xrotVal = (int)disp.xrot;
                                         xrtFld.setText( ""+xrotVal);
                                         yrotVal = (int)disp.yrot;
                                         yrtFld.setText( ""+yrotVal);
                                         zrotVal = (int)disp.zrot;
                                         zrtFld.setText( ""+zrotVal);
                                         pane.repaint();
                                        }
                                       };

/**
Action: auf grne Ebene drehen
*/
 private static Action greenAct = new AbstractAction() {
                                        public void actionPerformed( ActionEvent ae) {
                                         disp.xrot =  0;
                                         disp.yrot = 90;
                                         disp.zrot =  0;
                                         xrotVal = (int)disp.xrot;
                                         xrtFld.setText( ""+xrotVal);
                                         yrotVal = (int)disp.yrot;
                                         yrtFld.setText( ""+yrotVal);
                                         zrotVal = (int)disp.zrot;
                                         zrtFld.setText( ""+zrotVal);
                                         pane.repaint();
                                        }
                                       };

/**
Action: auf blaue Ebene drehen
*/
 private static Action blueAct = new AbstractAction() {
                                        public void actionPerformed( ActionEvent ae) {
                                         disp.xrot = 90;
                                         disp.yrot =  0;
                                         disp.zrot =  0;
                                         xrotVal = (int)disp.xrot;
                                         xrtFld.setText( ""+xrotVal);
                                         yrotVal = (int)disp.yrot;
                                         yrtFld.setText( ""+yrotVal);
                                         zrotVal = (int)disp.zrot;
                                         zrtFld.setText( ""+zrotVal);
                                         pane.repaint();
                                        }
                                       };

/**
Action: Punkte verbinden / nicht verbinden
*/
 private static Action cnctAct = new AbstractAction() {
                                        public void actionPerformed( ActionEvent ae) {
                                         connect = cnctChk.isSelected();
                                         pane.connect = connect;
                                         pane.repaint();
                                        }
                                       };

/**
Action: Raumachsen darstellen / nicht darstellen
*/
 private static Action shwaxAct = new AbstractAction() {
                                        public void actionPerformed( ActionEvent ae) {
                                         shwax = shwaxChk.isSelected();
                                         pane.shwax = shwax;
                                         pane.repaint();
                                        }
                                       };

/**
Action: Nur Punkte / nur Kreuze darstellen
*/
 private static Action dotsAct = new AbstractAction() {
                                        public void actionPerformed( ActionEvent ae) {
                                         cross = dotsChk.isSelected();
                                         disp.dots = !cross;
                                         pane.repaint();
                                        }
                                       };

/**
Action: Grundstellung wieder herstellen
*/
 private static Action base = new AbstractAction( "Grundstellung") {
                                        public void actionPerformed( ActionEvent ae) {
                                         generations = GEN;
                                         low         = LOW;
                                         connect     = CNT;
                                         shwax       = SWX;
                                         cross       = CRS;
                                         disp.xrot   = XRT;
                                         disp.yrot   = YRT;
                                         disp.zrot   = ZRT;
                                         disp.dots   = !CRS;
                                         pane.low = low;
                                         pane.set = createSet( generations);
                                         pane.connect = connect;
                                         pane.shwax = shwax;
                                         genFld.setText( ""+GEN);
                                         xrtFld.setText( ""+XRT);
                                         yrtFld.setText( ""+YRT);
                                         zrtFld.setText( ""+ZRT);
                                         cnctChk.setSelected(  connect);
                                         lowInt.setSelected( low);
                                         shwaxChk.setSelected( shwax);
                                         dotsChk.setSelected( cross);
                                         planeDummy.setSelected( true);
                                         pane.repaint();
                                        }
                                       };

/**
Action: Eingabefelder bernehmen
*/
 private static Action getFlds = new AbstractAction( "Neu Darstellen") {
                                        public void actionPerformed( ActionEvent ae) {
                                         generations = getGenerations();
                                         pane.set = createSet( generations);
                                         xrotVal = getXRotation();
                                         disp.xrot = xrotVal;
                                         yrotVal = getYRotation();
                                         disp.yrot = yrotVal;
                                         zrotVal = getZRotation();
                                         disp.zrot = zrotVal;
                                         planeDummy.setSelected( true);
                                         pane.repaint();
                                        }
                                       };

/**
Action: Peirce-Menge darstellen
*/
 private static Action prceAct = new AbstractAction() {
                                        public void actionPerformed( ActionEvent ae) {
                                         frmttl = TTL+CSP+FOR;
                                         frame.setTitle( frmttl);
                                         farset = !peirce.isSelected();
                                         if (generations > 14)
                                            {
                                             generations = 14;
                                             if (!cross) generations = 15;
                                             Toolkit.getDefaultToolkit().beep();
                                             genFld.setText( ""+generations);
                                            }
                                         pane.set = createSet( generations);
                                         pane.repaint();
                                        }
                                       };

/**
Action: Farey-Menge darstellen
*/
 private static Action freyAct = new AbstractAction() {
                                        public void actionPerformed( ActionEvent ae) {
                                         frmttl = TTL+JF+FOR;
                                         frame.setTitle( frmttl);
                                         farset = farey.isSelected();
                                         pane.set = createSet( generations);
                                         pane.repaint();
                                        }
                                       };

/**
Action: Ebene Rot ausblenden
*/
 private static Action noRedChk = new AbstractAction() {
                                        public void actionPerformed( ActionEvent ae) {
                                         disp.noRed = noRed.isSelected();
                                         pane.repaint();
                                        }
                                       };

/**
Action: Ebene Grn ausblenden
*/
 private static Action noGreenChk = new AbstractAction() {
                                        public void actionPerformed( ActionEvent ae) {
                                         disp.noGreen = noGreen.isSelected();
                                         pane.repaint();
                                        }
                                       };

/**
Action: Ebene Blau ausblenden
*/
 private static Action noBlueChk = new AbstractAction() {
                                        public void actionPerformed( ActionEvent ae) {
                                         disp.noBlue = noBlue.isSelected();
                                         pane.repaint();
                                        }
                                       };

static private JRadioButton planeDummy = new JRadioButton(); // Zum Zurcksetzen der Flchenauswahl

static private JRadioButton lowInt  = new JRadioButton( lowAct);
static private JRadioButton highInt = new JRadioButton( highAct);

static private JRadioButton peirce = new JRadioButton( prceAct);
static private JRadioButton farey  = new JRadioButton( freyAct);

static private JCheckBox cnctChk  = new JCheckBox( cnctAct);
static private JCheckBox shwaxChk = new JCheckBox( shwaxAct);
static private JCheckBox dotsChk  = new JCheckBox( dotsAct);

static private JCheckBox noRed   = new JCheckBox( noRedChk);
static private JCheckBox noGreen = new JCheckBox( noGreenChk);
static private JCheckBox noBlue  = new JCheckBox( noBlueChk);

  /**
  Neue Generation der Peirce- oder Farey-Folge erzeugen
  @param farey erzeugt Farey-Folge wenn true sonst Peirce-Folge
  @param set aktuelle Generation
  @return neue Generation
  */
 static Vector generate( boolean farey, Vector set) {
 Vector  sub   = new Vector(); // Teilmenge der neuen Generation
 int     index = 0;            // Index eines Elements
 int     limit = 1;            // kleinst mgliches Limit der Farey-Folge
 int     n;                    // Nenner in Elementen der Teilmenge
 int     z;                    // Zhler in Elementen der Teilmenge
 Element element;              // aktuelles Element

  if (set.size() > 1)
     limit = ((Element)set.elementAt( 1)).n+1; // vorhandenes Limit

  while (index < set.size()) // erste Hlfte von links-nach-rechts
        {
         element = (Element)set.elementAt( index);
         z = element.z;
         n = z + element.n;
         if   (farey)
              {
               if (limit >= n)
                   sub.addElement( new Element( z, n));
              }
         else sub.addElement( new Element( z, n));
         index++;
        }
  index = sub.size() - 1;    // Index auf letztes Element der Teilmenge
  if (((Element)sub.elementAt( index)).n == 2) index--;

  while (index >= 0)  // zweite Hlfte von rechts-nach-links
        {
         element = (Element)sub.elementAt( index);
         n = element.n;
         sub.addElement( new Element( n - element.z, n));
         index--;
        }
  return sub;
 }



 /**
 Bereitstellung der darzustellenden Menge
 @param gen Anzahl der Generationen
 @return Wertemenge
 */
 static public Vector createSet( int gen) {
 Vector set = new Vector();       // Menge der Peirce-Zahlen

  set.addElement( new Element()); // nulltes Element 0/1
/*
  set.addElement( new Element( 0, 1)); // Element = 0/1
  set.addElement( new Element( 1, 2)); // Element = 1/2
  set.addElement( new Element( 1, 1)); // Element = 1/1
*/
   for (int i = 0; i < gen; i++)  // Wertemenge aufbauen
        set = generate( farset, set);
  return set;
 }

 /**
 Koordination der gesamten Anwendung
 @param args wird nicht gebraucht
 */
 static public void main( String[] args) {
 JPanel panel = new JPanel();
 JPanel subpn = new JPanel();
 JPanel subp1 = new JPanel();
 JPanel p;
 JPanel p1;
 JPanel p0;

 Border raisedetched = BorderFactory.createEtchedBorder(EtchedBorder.RAISED);
 TitledBorder titled;
/*
  titled = BorderFactory.createTitledBorder(raisedetched, "title");
  titled.setTitleJustification( TitledBorder.CENTER);
*/
 JRadioButton planeRed   = new JRadioButton( redAct);
 JRadioButton planeGreen = new JRadioButton( greenAct);
 JRadioButton planeBlue  = new JRadioButton( blueAct);

  /*-------------------------------------*/
  /* Bereich mit RotationsIcons aufbauen */
  /*-------------------------------------*/

  p0 = new JPanel();
  p0.add( Box.createRigidArea( new Dimension(0, 20)));
  p0.setLayout( new BoxLayout( p0, BoxLayout.Y_AXIS));
  p0.add(Box.createVerticalGlue());

  titled = BorderFactory.createTitledBorder(raisedetched, "Rotation des Raumes");
  titled.setTitleJustification( TitledBorder.CENTER);
  subpn.setLayout( new BoxLayout( subpn, BoxLayout.Y_AXIS));
  p = new JPanel();
  p.add( new JButton( wrot));  // Action: Rotation um X-Achse in positive Richtung
  subpn.add( p);
  subpn.add(Box.createVerticalGlue());
  p = new JPanel();
  p.add( new JButton( yrot));  // Action: Rotation um Y-Achse in negative Richtung
  p1 = new JPanel();
  p1.setLayout( new BoxLayout( p1, BoxLayout.Y_AXIS));
  p1.add( new JButton( urot)); // Action: Rotation um Z-Achse in positive Richtung
  p1.add( new JButton( vrot)); // Action: Rotation um Z-Achse in negative Richtung
  p.add( p1);
  p.add( new JButton( zrot));  // Action: Rotation um Y-Achse in positive Richtung
  subpn.add( p);
  subpn.add(Box.createVerticalGlue());
  p = new JPanel();
  p.add( new JButton( xrot));  // Action: Rotation um X-Achse in positive Richtung
  subpn.add( p);
  subpn.setBorder( titled);
  p0.add( subpn);
  p0.add( Box.createRigidArea( new Dimension(0, 20)));

  subpn = new JPanel();
  titled = BorderFactory.createTitledBorder(raisedetched, "Eingaben mit Besttigung");
  titled.setTitleJustification( TitledBorder.CENTER);
  subpn.setLayout( new BoxLayout( subpn, BoxLayout.Y_AXIS));
  p = new JPanel();
  p.add( new JLabel( "             Generationen"));
  p.add( genFld);
  subpn.add( p);
  p = new JPanel();
  p.add( new JLabel( "Rotation um X-Achse"));
  p.add( xrtFld);
  xrtFld.setText( ""+xrotVal);
  subpn.add( p);
  p = new JPanel();
  p.add( new JLabel( "Rotation um Y-Achse"));
  p.add( yrtFld);
  yrtFld.setText( ""+yrotVal);
  subpn.add( p);
  p = new JPanel();
  p.add( new JLabel( "Rotation um Z-Achse"));
  p.add( zrtFld);
  zrtFld.setText( ""+zrotVal);
  subpn.add( p);
  p = new JPanel();
  p.add( new JButton( getFlds)); // Eingabefelder bernehmen
  genFld.setText( ""+generations);
  subpn.add( p);
  subpn.setBorder( titled);
  p0.add( subpn);

  p0.add( Box.createRigidArea( new Dimension(0, 20)));
  subp1 = new JPanel();
  subp1.setLayout( new BoxLayout( subp1, BoxLayout.Y_AXIS));
  p = new JPanel();
  p.add( new JLabel( "Punkte verbinden           "));
  p.add( cnctChk);
  subp1.add( p);
  p = new JPanel();
  p.add( new JLabel( "Raumpunkte als Kreuze "));
  p.add( dotsChk);
  dotsChk.setSelected( cross);
  subp1.add( p);
  p = new JPanel();
  p.add( new JLabel( "Raumachsen einblenden"));
  p.add( shwaxChk);
  subp1.add( p);
  subp1.add( Box.createRigidArea( new Dimension(0, 20)));

  subpn = new JPanel();
  titled = BorderFactory.createTitledBorder(raisedetched, "Ebenen allein darstellen");
  titled.setTitleJustification( TitledBorder.CENTER);
 ButtonGroup planeGroup = new ButtonGroup();
  planeGroup.add( planeRed);
  planeGroup.add( planeGreen);
  planeGroup.add( planeBlue);
  planeGroup.add( planeDummy);
  p = new JPanel();
  p.add( new JLabel( "rot"));
  p.add( planeRed);
  p.add( new JLabel( " grn"));
  p.add( planeGreen);
  p.add( new JLabel( " blau"));
  p.add( planeBlue);
  subpn.setBorder( titled);
  subpn.add( p);
  subp1.add( subpn);

  subpn = new JPanel();
  titled = BorderFactory.createTitledBorder(raisedetched, "Ebenen ausblenden");
  subp1.add( Box.createRigidArea( new Dimension(0, 20)));
  p = new JPanel();
  p.add( new JLabel( "rot"));
  p.add( noRed);
  p.add( new JLabel( " grn"));
  p.add( noGreen);
  p.add( new JLabel( " blau"));
  p.add( noBlue);
  subpn.setBorder( titled);
  subpn.add( p);
  subp1.add( subpn);
  titled = BorderFactory.createTitledBorder( raisedetched, "Anzeigeoptionen");
  titled.setTitleJustification( TitledBorder.CENTER);
  subp1.setBorder( titled);
  p0.add( subp1);


  p0.add( Box.createRigidArea( new Dimension(0, 20)));
 ButtonGroup setGroup = new ButtonGroup();
 setGroup.add( peirce);
 setGroup.add( farey);
  p = new JPanel();
  p.add( new JLabel( "Peirce"));
  p.add( peirce);
  peirce.setSelected( !farset);
  p.add( new JLabel( "Farey"));
  p.add( farey);
  farey.setSelected( farset);
  p0.add( p);

 ButtonGroup intGroup = new ButtonGroup();
  intGroup.add( lowInt);
  intGroup.add( highInt);
  p = new JPanel();
  p.add( new JLabel( "Intervall:   [0, 1]"));
  p.add( lowInt);
  p.add( new JLabel( "[0, ?]"));
  p.add( highInt);
  p0.add( p);

  p0.add( Box.createRigidArea( new Dimension(0, 20)));
  p = new JPanel();
  p.add( new JButton( base));
  p0.add( p);

  p0.add( Box.createRigidArea( new Dimension(0, 100)));

  panel.setLayout( new BorderLayout());
  panel.add( BorderLayout.CENTER, p0);

  // Pane mit 3D-Display ins Zentrum

  disp = new Disp3D();
  disp.xrot   = XRT;
  disp.yrot   = YRT;
  disp.zrot   = ZRT;
  pane = new TestPane( disp,                    // 3D-Display
                       createSet( generations), // 10 Generationen Menge
                       low,                     // true  = [0...1]-Intervall
                       connect);                // false = Punkte nicht verbinden

  if   (pane.low)
       {
        lowInt.setSelected( true);
       }
  else {
        highInt.setSelected( true);
       }

  // Darstellen

  frame = new JFrame();
  frame.setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE);
  frame.setTitle( frmttl);
  frame.setSize( frameW, frameH);
  frame.getContentPane().setLayout( new BorderLayout());
  frame.getContentPane().add( BorderLayout.WEST,   panel);
  frame.getContentPane().add( BorderLayout.CENTER, pane);
  frame.show();
 }
}
